package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.joinProtection;

import eu.mhsl.craftattack.core.Main;
import eu.mhsl.craftattack.core.appliance.Appliance;
import net.kyori.adventure.util.Ticks;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.Listener;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;
import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class JoinProtection extends Appliance {
    private static final int resistanceDuration = 30;

    private final List<UUID> protectedPlayers = new ArrayList<>();

    public void addProtection(Player player) {
        protectedPlayers.add(player.getUniqueId());
        PotionEffect effect = new PotionEffect(PotionEffectType.RESISTANCE, Ticks.TICKS_PER_SECOND*resistanceDuration, 1);
        player.addPotionEffect(effect, true);
        Bukkit.getScheduler().runTaskLater(
            Main.instance(),
            () -> protectedPlayers.remove(player.getUniqueId()),
            Ticks.TICKS_PER_SECOND*resistanceDuration
        );
    }

    public void cancelEvent(Player player, Cancellable event) {
        if(!protectedPlayers.contains(player.getUniqueId())) return;
        event.setCancelled(true);
    }

    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(new JoinProtectionListener());
    }
}
