package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.joinProtection;

import eu.mhsl.craftattack.core.appliance.ApplianceListener;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.player.*;

public class JoinProtectionListener extends ApplianceListener<JoinProtection> {
    @EventHandler
    public void onJoin(PlayerJoinEvent event) {
        this.getAppliance().addProtection(event.getPlayer());
    }

    @EventHandler
    public void onDamage(EntityDamageEvent event) {
        if(!(event.getEntity() instanceof Player)) return;
        this.getAppliance().cancelEvent((Player) event.getEntity(), event);
    }

    @EventHandler
    public void onConsume(PlayerItemConsumeEvent event) {
        this.getAppliance().cancelEvent(event.getPlayer(), event);
    }

    // flying is not enabled on the server
    @EventHandler
    public void onMove(PlayerMoveEvent event) {
        if(!event.hasChangedPosition()) return;
        this.getAppliance().cancelEvent(event.getPlayer(), event);
    }

    @EventHandler
    public void onInteract(PlayerInteractEvent event) {
        this.getAppliance().cancelEvent(event.getPlayer(), event);
    }

    @EventHandler
    public void onBlockPlace(BlockPlaceEvent event) {
        this.getAppliance().cancelEvent(event.getPlayer(), event);
    }

    @EventHandler
    public void onBlockBreak(BlockBreakEvent event) {
        this.getAppliance().cancelEvent(event.getPlayer(), event);
    }
}
